<?php
/**
* @author Steve(c) @ www.phpbbandbbcodes.com 
* @version $Id$ 1.0.1 20/03/2012
* @copyright (c) 2007 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

// Additional tables
define('INFO_BOXES_TABLE', $table_prefix . 'info_boxes');

function preview_info_box($message)
{
	$message = utf8_normalize_nfc($message);
    $uid = $bitfield = $options = '';
    $allow_bbcode = $allow_urls = $allow_smilies = true;
	generate_text_for_storage($message, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);
	$message = generate_text_for_display($message, $uid, $bitfield, $options);
	return $message;
}

function info_boxes(&$hook)
{
	global $auth, $cache, $config, $db, $template, $user;
	global $phpbb_root_path, $phpEx;
		
	//thanks rich ;) http://www.phpbb.com/community/viewtopic.php?f=46&t=2125132
	$query_string = str_replace('mode=', '', $user->page['query_string']);
	//Dont hook on page + mode.
	$what_page = explode(".", $user->page['page']);
	if($what_page[0] == 'adm/index'  && $query_string == 'email' || $what_page[0] == 'ucp')
	{
		return;
	}
		
	if ((!empty($config['info_boxes_adv_version']) ? true : false) && (!empty($config['enable_info_box_adv']) ? true : false))
	{ 
	
	//Add our language file.
	$user->add_lang('mods/info_boxes_lang');
	$u_info_box_adv = ($auth->acl_get('u_info_box_adv')) ? true : false;
	
	// Collect
		$sql = 'SELECT *
			FROM ' . INFO_BOXES_TABLE . '
			ORDER BY time DESC';
		$result = $db->sql_query_limit($sql, 1);
		$data_info = $db->sql_fetchrow($result);     
		$db->sql_freeresult($result);	

		$exp_date = $data_info['time'] + ($data_info['display_until']);
		$todays_date = time();
		$time = $data_info['time'];

		if ($exp_date > $todays_date || $data_info['display_until'] == 0) 
		{ 	
			$flags = (($config['allow_bbcode']) ? 1 : 0) + (($config['allow_smilies']) ? 2 : 0) + ((true) ? 4 : 0);
			$message = generate_text_for_display($data_info['message'], $data_info['bbcode_uid'], $data_info['bbcode_bitfield'], $flags);

			$template->assign_vars(array(
				'MESSAGE_INDEX'				=> (isset($message)) ? $message : '',
				'TITLE_INDEX'				=> (isset($data_info['title'])) ? $data_info['title'] : '',
				'TIME_INDEX'				=> $user->format_date($data_info['time']),
				'DISPLAYS_UNTIL'			=> ($data_info['display_until'] == 0) ? $user->lang['ALL_WAYS'] : $user->format_date($exp_date),
				'BACKGROUND_COLOR_INDEX'	=> (isset($data_info['background_color'])) ? $data_info['background_color'] : '',
				'BORDER_COLOR_INDEX'		=> (isset($data_info['border_color'])) ? $data_info['border_color'] : '',
				'INFO_BOX_IMAGE'			=> $phpbb_root_path . $config['info_path'] . '/' . $data_info['info_image'],	
				'S_DISPLAY_END'				=> (!empty($data_info['display_end'])) ? true : false,
				'S_DISPLAY_INDEX_PAGE'		=> (!empty($data_info['display_index'])) ? true : false,
				'U_INFO_BOXES'   			=> ($u_info_box_adv) ? append_sid("{$phpbb_root_path}info_boxes.$phpEx") : '',
				'U_INFO_BOX_ALLOWED'		=> $u_info_box_adv,
			));
		}

			$template->assign_vars(array(	
				'U_INFO_BOXES'   		=> ($u_info_box_adv) ? append_sid("{$phpbb_root_path}info_boxes.$phpEx") : '',
				'U_INFO_BOX_ALLOWED'	=> $u_info_box_adv,
			));
	}	
}

// Register
$phpbb_hook->register('phpbb_user_session_handler', 'info_boxes');

?>