<?php
/**
*
* @package Info Boxes Steve(c)
* @version $Id: 1.0.1 
* @copyright (c) 2007 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('posting');

// For submitting
$submit	= (isset($_POST['submit'])) ? true : false;
$error = array();
$preview = (isset($_POST['preview'])) ? true : false;
// Include the file
include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
// Some vars at the top please
$info_boxes_id = request_var('i_b', 0);
$mode = request_var('info_boxes', '');	
$start = request_var('start', 0);
$u_info_box_adv = ($auth->acl_get('u_info_box_adv')) ? true : false;
$enabled_info_box = (!empty($config['enable_info_box_adv']) ? true : false);
// A link
$info_boxes = append_sid("{$phpbb_root_path}info_boxes.$phpEx");
$index = append_sid("{$phpbb_root_path}index.$phpEx");
// Form key	
add_form_key('info_boxes');
// Lets go .......

	global $db, $user, $template;
	global $config, $phpbb_root_path, $phpEx;	
	
	if (!$enabled_info_box)
	{ 
		meta_refresh(3, $index);
		$message = $user->lang['INFO_BOXES_DISABLED'] . '<br /><br />' . '<a href="' . $index . '">' . $user->lang['RETURN_INDEX_PAGE'] . '</a>';
		trigger_error($message);
	}	
	if (!$u_info_box_adv)
	{
		meta_refresh(3, $index);
		$message = $user->lang['NO_AUTH_INFO'] . '<br /><br />' . '<a href="' . $index . '">' . $user->lang['RETURN_INDEX_PAGE'] . '</a>';
		trigger_error($message);
	}	
	
	switch ($mode)
	{	
		// Add
	    case 'add':
		
			// Admin only
			if ($auth->acl_get('a_') != true)
			{
				meta_refresh(3, $info_boxes);
				$message = $user->lang['NO_AUTH'] . '<br /><br />' . '<a href="' . $info_boxes . '">' . $user->lang['RETURN_INFO_BOXES'] . '</a>';
				trigger_error($message);
			}
				
            // Request required info
			$data = array(
				'info_boxes_id'		=> request_var('i_b', 0),
				$message			= utf8_normalize_nfc(request_var('message','', true)),
				$title				= utf8_normalize_nfc(request_var('title','', true)),
				$display_index		= request_var('display_index', 0),
				$info_image			= utf8_normalize_nfc(request_var('info_image', '', true)),
				$display_until		= request_var('display_until','', true),
				$border_color		= utf8_normalize_nfc(request_var('border_color','', true)),
				$background_color	= utf8_normalize_nfc(request_var('background_color','', true)),				
			);
				
			if ($submit)
			{   
			
			if(!empty($config['enable_archive_limit']) ? true : false)
			{
			// Collect
				$sql = 'SELECT *
					FROM ' . INFO_BOXES_TABLE . '
					ORDER BY time ASC';//Lol DESC deleted the first nub
				$result = $db->sql_query_limit($sql, 1);
				$data = $db->sql_fetchrow($result);     
				$info_box_id = (int) $data['info_boxes_id'];
			
				//Counting info boxes
				$sql = 'SELECT COUNT(info_boxes_id) AS info_boxes_count FROM ' . INFO_BOXES_TABLE;
				$result = $db->sql_query($sql);
				$info_boxes_count = (int) $db->sql_fetchfield('info_boxes_count');
				$db->sql_freeresult($result);
				
				//12(z - y) + m (less 1 than count as it show's 6 :? /archive $config later
				$archive_limit = (isset($config['archive_limit'])) ? ($config['archive_limit'] - 1) : '';
				$prune_id = ($info_boxes_count - $archive_limit) + $info_box_id;
					
				// grr... thats why >= != [gte] ...nub
				if($info_boxes_count > $archive_limit)
				{
				$sql = 'DELETE FROM ' . INFO_BOXES_TABLE . '
					WHERE info_boxes_id < ' . (int) $prune_id;
				$db->sql_query($sql);
				}
			}
			
			if(!check_form_key('info_boxes'))
			{
				$error[] = $user->lang['FORM_INVALID'];
			}
			// Validate message
			if (!$message)
			{
				$error[] = $user->lang['INFO_NO_MESSAGE'];
			}
			// Validate title
			if (!$title)
			{
				$error[] = $user->lang['INFO_NO_TITLE'];
			}
			// The rank image has to be a jpg, gif or png
			if ($info_image != '' && !preg_match('#(\.gif|\.png|\.jpg|\.jpeg)$#i', $info_image))
			{
				$info_image = '';
			}
			
			if (!sizeof($error))
			{		
				//				
				$uid = $bitfield = $options = ''; 				
				generate_text_for_storage($message, $uid, $bitfield, $options, true, true, true);
				$display_until = $display_until * 86400;
				
				$mod_link = $title;
				// Replace any chars which may cause us problems with 
				$bad_chars = array("'", '>', '<',  "\\", ' ', '/', ':', '*', '?', '"','|');
				$mod_link = str_replace($bad_chars, ' ', $mod_link);
			
					$sql_ary = array(
						'info_boxes_id' 		=> (int) $info_boxes_id,
						'message'     			=> $message,
						'title'					=> $mod_link,
						'background_color'		=> $background_color,
						'border_color'			=> $border_color,
						'info_image'			=> $info_image,
						'time'					=> (int) time(),
						'display_index'			=> (bool) $display_index,
						'display_until'			=> $display_until,
						'bbcode_uid'			=> $uid,
						'bbcode_bitfield'		=> $bitfield,
					);					

				$sql = 'INSERT INTO ' . INFO_BOXES_TABLE .  $db->sql_build_array('INSERT', $sql_ary);
				$db->sql_query($sql);
							
				// All done?
				meta_refresh(3, $info_boxes);
				$message = $user->lang['PAGE_CREATED'] . '<br /><br />' . '<a href="' . $info_boxes . '">' . $user->lang['RETURN_INFO_BOXES'] . '</a>';
				trigger_error($message);

			}
			
			// Replace "error" strings with their real, localised form
				$error = preg_replace('#^([A-Z_]+)$#e', "(!empty(\$user->lang['\\1'])) ? \$user->lang['\\1'] : '\\1'", $error);
			}

			// Preview
			if ($preview && !sizeof($error))
			{
				$preview = preview_info_box($message);

			if (!sizeof($error))
			{
				$template->assign_vars(array(
					'MESSAGE_P'				=> $preview,
					'S_DISPLAY_PREVIEW'		=> true)
				);
			}
			}	
			
			require($phpbb_root_path . 'includes/mods/get_list.' . $phpEx);
			$quote_status = true;

			$template->assign_vars(array(
				'ERROR'		    		=> (sizeof($error)) ? implode('<br />', $error) : '',
				'MESSAGE'				=> (isset($message)) ? $message : '',
				'TITLE'					=> $title,
				'BACKGROUND_COLOR'		=> $background_color,
				'BORDER_COLOR'			=> $border_color,
				'S_DISPLAY_INDEX'		=> (!empty($display_index)) ? true : false,
				'DISPLAY_UNTIL'			=> $display_until,				
				'U_MORE_SMILIES'    	=> append_sid("{$phpbb_root_path}posting.$phpEx", 'mode=smilies'),	
				'U_SWATCH'				=> append_sid("{$phpbb_root_path}swatch.$phpEx", 'form=postform&amp;name=border_color'),
				'U_SWATCH_BACKGROUND'	=> append_sid("{$phpbb_root_path}swatch.$phpEx", 'form=postform&amp;name=background_color'),				
				'S_INFO_BOXES_CREATE'	=> true,
				'U_INFO_BOXES'    		=> $info_boxes,		
				'S_ACTION'				=> append_sid("{$phpbb_root_path}info_boxes.$phpEx", 'info_boxes=add', true, $user->session_id),
				'S_BBCODE_ALLOWED'		=> (!empty($config['allow_bbcode'])) ? true : false,
				'S_BBCODE_QUOTE'		=> $quote_status,
				'S_BBCODE_IMG'			=> (!empty($config['allow_bbcode'])) ? true : false,
				'S_BBCODE_FLASH'		=> (!empty($config['allow_post_flash'])) ? true : false,
				'S_LINKS_ALLOWED'		=> (!empty($config['allow_post_links'])) ? true : false,	
				'S_FILENAME_LIST'		=> $filename_list,
				'INFO_BOX_IMAGE'		=> ($edit_img) ? $phpbb_root_path . $config['info_path'] . '/' . $edit_img :  '',	
				'INFO_BOX_PATH'			=> $phpbb_root_path . $config['info_path'],	

			));				
		
		if ($config['allow_bbcode'])
		{
			if (!function_exists('display_custom_bbcodes'))
			{
				include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
				display_custom_bbcodes();
		}
			if ($config['allow_smilies'])
			{	
				// Lets start smiling if this works!! :)
				generate_smilies('inline', 0);	
			}	
		}
		
		break; // Could do with one !!
		
		case 'edit':
		
			if ($auth->acl_get('a_') != true)
			{
				meta_refresh(3, $info_boxes);
				$message = $user->lang['NO_AUTH'] . '<br /><br />' . '<a href="' . $info_boxes . '">' . $user->lang['RETURN_INFO_BOXES'] . '</a>';
				trigger_error($message);
			}
				
            // request required info
			$data = array(
				'info_boxes_id'		=> request_var('i_b', 0),
				$message			= utf8_normalize_nfc(request_var('message','', true)),
				$title				= utf8_normalize_nfc(request_var('title','', true)),
				'display_end'		=> request_var('display_end', 0),
				'display_index'		=> request_var('display_index', 0),
				'display_until'		=> request_var('display_until', ''),
				$info_image			= utf8_normalize_nfc(request_var('info_image', '', true)),				
				$border_color		= utf8_normalize_nfc(request_var('border_color','', true)),
				$background_color	= utf8_normalize_nfc(request_var('background_color','', true)),
			);
				
			if ($submit)
			{   
			if(!check_form_key('info_boxes'))
			{
				$error[] = $user->lang['FORM_INVALID'];
			}
			// validate message
			if (!$message)
			{
				$error[] = $user->lang['INFO_NO_MESSAGE'];
			}
			// validate title
			if (!$title)
			{
				$error[] = $user->lang['INFO_NO_TITLE'];
			}
			// The rank image has to be a jpg, gif or png
			if ($info_image != '' && !preg_match('#(\.gif|\.png|\.jpg|\.jpeg)$#i', $info_image))
			{
				$info_image = '';
			}
			
			if (!sizeof($error))
			{		
				//				
				$uid = $bitfield = $options = ''; 				
				generate_text_for_storage($message, $uid, $bitfield, $options, true, true, true);
				 
				$display_until = $data['display_until'] * 86400;
				$mod_link = $title;
				// Replace any chars which may cause us problems with _
				$bad_chars = array("'", '>', '<',  "\\", ' ', '/', ':', '*', '?', '"','|');
				$mod_link = str_replace($bad_chars, ' ', $mod_link);
			
					$sql_ary = array(
						'info_boxes_id' 		=> (int) $info_boxes_id,
						'message'     			=> $message,
						'title'					=> $mod_link,
						'background_color'		=> $background_color,
						'border_color'			=> $border_color,
						'display_end'			=> (bool) $data['display_end'],
						'display_index'			=> (bool) $data['display_index'],
						'display_until'			=> $display_until,
						'info_image'			=> $info_image,						
						'update_time'			=> (int) time(),
						'bbcode_uid'			=> $uid,
						'bbcode_bitfield'		=> $bitfield,
					);

				$sql = 'UPDATE ' . INFO_BOXES_TABLE . '
					SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
						WHERE info_boxes_id = ' . (int) $info_boxes_id ;
				$db->sql_query($sql);
			
				// All done?   
				meta_refresh(3, $info_boxes);
				$message = $user->lang['PAGE_UPDATED'] . '<br /><br />' . '<a href="' . $info_boxes . '">' . $user->lang['RETURN_INFO_BOXES'] . '</a>';
				trigger_error($message);

			// Replace "error" strings with their real, localised form
				$error = preg_replace('#^([A-Z_]+)$#e', "(!empty(\$user->lang['\\1'])) ? \$user->lang['\\1'] : '\\1'", $error);
			}
				
		}	
	
		// Collect
			$sql = 'SELECT *
				FROM ' . INFO_BOXES_TABLE . '
				WHERE info_boxes_id = ' . (int) $info_boxes_id;
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result); 
			$db->sql_freeresult($result);
			
			$info_image = $row['info_image'];
			
			require($phpbb_root_path . 'includes/mods/get_list.' . $phpEx);
			
			$message = $row['message'];
			$quote_status = true;
			decode_message($message, (isset($row['bbcode_uid'])) ? $row['bbcode_uid'] : '');
		
			$template->assign_vars(array(
				'ERROR'		    	=> (sizeof($error)) ? implode('<br />', $error) : '',
				'MESSAGE'			=> (isset($message)) ? $message : '',
				'TITLE'				=> (isset($row['title'])) ? $row['title'] : '',
				'TIME'				=> (isset($row['time'])) ? $row['time'] : '',
				'BACKGROUND_COLOR'	=> (isset($row['background_color'])) ? $row['background_color'] : '',
				'BORDER_COLOR'		=> (isset($row['border_color'])) ? $row['border_color'] : '',
				'S_DISPLAY_END'		=> (!empty($row['display_end'])) ? true : false,
				'S_DISPLAY_INDEX'		=> (!empty($row['display_index'])) ? true : false,
				'DISPLAY_UNTIL'			=> $row['display_until'] / 86400,
				'U_MORE_SMILIES'    	=> append_sid("{$phpbb_root_path}posting.$phpEx", 'mode=smilies'),	
				'U_SWATCH'				=> append_sid("{$phpbb_root_path}swatch.$phpEx", 'form=postform&amp;name=border_color'),
				'U_SWATCH_BACKGROUND'	=> append_sid("{$phpbb_root_path}swatch.$phpEx", 'form=postform&amp;name=background_color'),					
				'S_INFO_BOXES_CREATE'	=> true,
				'S_MODE_EDIT'			=> true,
				'U_INFO_BOXES'    		=> $info_boxes,	
				'S_ACTION'				=> append_sid("{$phpbb_root_path}info_boxes.$phpEx", 'info_boxes=edit&amp;i_b=' . $info_boxes_id, true, $user->session_id),
				'S_BBCODE_ALLOWED'		=> (!empty($config['allow_bbcode'])) ? true : false,
				'S_BBCODE_QUOTE'		=> $quote_status,
				'S_BBCODE_IMG'			=> (!empty($config['allow_bbcode'])) ? true : false,
				'S_BBCODE_FLASH'		=> (!empty($config['allow_post_flash'])) ? true : false,
				'S_LINKS_ALLOWED'		=> (!empty($config['allow_post_links'])) ? true : false,
				'S_FILENAME_LIST'		=> $filename_list,
				'INFO_BOX_IMAGE'		=> ($edit_img) ? $phpbb_root_path . $config['info_path'] . '/' . $edit_img : '',	
				'INFO_BOX_PATH'			=> $phpbb_root_path . $config['info_path'],				
			));				
		
		if ($config['allow_bbcode'])
		{
			if (!function_exists('display_custom_bbcodes'))
			{
				include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
				display_custom_bbcodes();
		}
			if ($config['allow_smilies'])
			{	
				// Lets start smiling if this works!! :)
				generate_smilies('inline', 0);	
			}	
		}

		break; 
		
		case 'delete':
		
			$info_boxes_id = request_var('i_b', 0);		

			$sql = 'SELECT info_boxes_id, title
				FROM ' . INFO_BOXES_TABLE . '
				WHERE  info_boxes_id = ' . (int) $info_boxes_id;
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);

			if ($auth->acl_get('a_') != true)
			{
				meta_refresh(3, $info_boxes);
				$message = $user->lang['NO_AUTH'] . '<br /><br />' . '<a href="' . $info_boxes . '">' . $user->lang['RETURN_INFO_BOXES'] . '</a>';
				trigger_error($message);
			}

			if(confirm_box(true))
			{
				$sql = 'DELETE FROM ' . INFO_BOXES_TABLE . '
					WHERE info_boxes_id = ' . (int) $info_boxes_id;
				$result = $db->sql_query_limit($sql, 1);
				
				add_log('admin', 'LOG_INFO_BOXES_DELETED', $row['title']); 
				
				meta_refresh(3, $info_boxes);
				$message = $user->lang['INFO_BOXES_DELETED'] . '<br /><br />' . '<a href="' . $info_boxes . '">' . $user->lang['RETURN_INFO_BOXES'] . '</a>';
				trigger_error($message);				
			}
			else
			{
				confirm_box(false, $user->lang['DELETE_INFO_BOXES']);	
			}
					
		break;
		
		case 'info_boxes':
		
		// Collect
			$sql = 'SELECT *
				FROM ' . INFO_BOXES_TABLE . '
				WHERE info_boxes_id = ' . (int) $info_boxes_id . '
				ORDER BY time ASC';
			$result = $db->sql_query($sql);
			$data = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);	
		
			$flags = (($config['allow_bbcode']) ? 1 : 0) + (($config['allow_smilies']) ? 2 : 0) + ((true) ? 4 : 0);
			$message = generate_text_for_display($data['message'], $data['bbcode_uid'], $data['bbcode_bitfield'], $flags);
			$exp_date = $data['time'] + ($data['display_until']);
			
			$template->assign_vars(array(
				'MESSAGE'				=> $message,
				'TITLE'					=> $data['title'],
				'BACKGROUND_COLOR'		=> $data['background_color'],
				'BORDER_COLOR'			=> $data['border_color'],
				'POSTED_TIME'			=> $user->format_date($data['time']),
				'DISPLAYS_UNTIL'		=> ($data['display_until'] == 0) ? $user->lang['ALL_WAYS'] : $user->format_date($exp_date),
				'S_CAT'					=> true,	
				'U_INFO_BOXES_EDIT'    	=> append_sid("{$phpbb_root_path}info_boxes.$phpEx", 'info_boxes=edit&amp;i_b=' . $info_boxes_id),
				'U_INFO_BOXES_DELETE'   => append_sid("{$phpbb_root_path}info_boxes.$phpEx", 'info_boxes=delete&amp;i_b=' . $info_boxes_id),
				'INFO_BOX_IMAGE'		=> $phpbb_root_path . $config['info_path'] . '/' . $data['info_image'],	
				
			));
		
		default;
	}	
	
		if (!empty($config['info_boxes_adv_version']) ? true : false) 
		{ 
			// Collect
			$sql = 'SELECT *
				FROM ' . INFO_BOXES_TABLE . '
				ORDER BY time DESC';
			$result = $db->sql_query_limit($sql, $config['posts_per_page'], $start);

			while ($row = $db->sql_fetchrow($result))
			{
				$mod_link = $row['title'];
				// Replace any chars which may cause us problems with _
				$bad_chars = array("'", "\\", ' ', '/', ':', '*', '?', '"', '<', '>', '|');
				$mod_link = str_replace($bad_chars, '_', $mod_link);
				
				$flags = (($config['allow_bbcode']) ? 1 : 0) + (($config['allow_smilies']) ? 2 : 0) + ((true) ? 4 : 0);
				$message = generate_text_for_display($row['message'], $row['bbcode_uid'], $row['bbcode_bitfield'], $flags);
			
				$time = $row['time'];
				$exp_date = $row['time'] + ($row['display_until']);

				$template->assign_block_vars('info_boxes', array(
					'MESSAGE'			=> $message,
					'POSTED_TIME'		=> $user->format_date($time),
					'S_DISPLAY_INDEX'	=> ($row['display_index']) ? true : false,
					'DISPLAYS_UNTIL'	=> ($row['display_until'] == 0) ? $user->lang['ALL_WAYS'] : $user->format_date($exp_date),
					'TITLE'				=> $row['title'],	
					'BACKGROUND_COLOR'	=> $row['background_color'],
					'BORDER_COLOR'		=> $row['border_color'],
					'INFO_BOX_IMAGE'	=> $phpbb_root_path . $config['info_path'] . '/' . $row['info_image'],
					'U_INFO_BOXES_CAT'	=> append_sid("{$phpbb_root_path}info_boxes.$phpEx", 'info_boxes=info_boxes&amp;i_b=' . $row['info_boxes_id'] . '&amp;' . $mod_link),
					'U_INFO_BOXES_EDIT'    	=> append_sid("{$phpbb_root_path}info_boxes.$phpEx", 'info_boxes=edit&amp;i_b=' . $row['info_boxes_id']),
					'U_INFO_BOXES_DELETE'   => append_sid("{$phpbb_root_path}info_boxes.$phpEx", 'info_boxes=delete&amp;i_b=' . $row['info_boxes_id']),				
				));
			}
			
			//For our menu other wise it get cuts off with pagination
			$sql = 'SELECT *
				FROM ' . INFO_BOXES_TABLE . '
				ORDER BY time DESC';
			$result = $db->sql_query($sql);

			while ($menu_row = $db->sql_fetchrow($result))
			{
				$mod_link = $menu_row['title'];
				// Replace any chars which may cause us problems with _ ,even tho we checked this on submit in add/edit mode
				$bad_chars = array("'", "\\", ' ', '/', ':', '*', '?', '"', '<', '>', '|');
				$mod_link = str_replace($bad_chars, '_', $mod_link);
				
				$template->assign_block_vars('info_boxesmenu', array(
					'TITLE'				=> $menu_row['title'],	
					'U_INFO_BOXES_CAT'	=> append_sid("{$phpbb_root_path}info_boxes.$phpEx", 'info_boxes=info_boxes&amp;i_b=' . $menu_row['info_boxes_id'] . '&amp;' . $mod_link),
				));			
			}
			$db->sql_freeresult($result);
			
			$sql = 'SELECT COUNT(info_boxes_id) AS info_boxes_count FROM ' . INFO_BOXES_TABLE;
			$result = $db->sql_query($sql);
			$info_boxes_counts = (int) $db->sql_fetchfield('info_boxes_count');
			$db->sql_freeresult($result);
		
			$template->assign_vars(array(		
				'COUNT_INFO_BOXES'    	=> $info_boxes_counts,
				'U_INFO_BOXES'    		=> $info_boxes,
				'U_INFO_BOX_ALLOWED'	=> $u_info_box_adv,
				'U_INFO_BOXES_CREATE'   => append_sid("{$phpbb_root_path}info_boxes.$phpEx", 'info_boxes=add'),
				'PAGINATION'			=> generate_pagination($info_boxes, $info_boxes_counts, $config['posts_per_page'], $start),
				'S_ON_PAGE'				=> on_page($info_boxes_counts, $config['posts_per_page'], $start),
			));
		}
		
// Just wrapping it all up!	
// template file
$template->set_filenames(array(
    'body' => 'info_boxes_body.html',
));
// navlinks
$template->assign_block_vars('navlinks', array(
	'FORUM_NAME'		=> $user->lang('PAGE_NAME'),
	'U_VIEW_FORUM'		=> append_sid("{$phpbb_root_path}info_boxes.$phpEx"),
));		
// Page title
page_header($user->lang['PAGE_NAME']);
// Lets get out of here!
make_jumpbox(append_sid("{$phpbb_root_path}viewforum.$phpEx"));
// End the page we are on ...
page_footer();

?>