<?php
/**
*
* @author Steve(c) @ www.phpbbandbbcodes.com 
* @version $Id$ 1.0.0 14/01/2012
* @package umil
* @copyright (c) 2008 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('UMIL_AUTO', true);
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
$user->session_begin();
$auth->acl($user->data);
$user->setup();

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}
/*
* The language file which will be included when installing
*/
$language_file = 'mods/info_boxes_lang';

// The name of the mod to be displayed during installation.
$mod_name = 'INFO_BOXES_ADV';

/*
* The name of the config variable which will hold the currently installed version
* You do not need to set this yourself, UMIL will handle setting and updating the version itself.
*/
$version_config_name = 'info_boxes_adv_version';

/*
* The array of versions and actions within each.
* You do not need to order it a specific way (it will be sorted automatically), however, you must enter every version, even if no actions are done for it.
*
* You must use correct version numbering.  Unless you know exactly what you can use, only use X.X.X (replacing X with an integer).
* The version numbering must otherwise be compatible with the version_compare function - http://php.net/manual/en/function.version-compare.php
*/
$versions = array(

    // Version 1.0.0
    '1.0.0'   => array(
		
	// Lets add a config setting and set it to true
		'config_add' => array(
			array('enable_info_box_adv', true),
        ),
			
	// Now to add some permission settings
		'permission_add' => array(
			array('u_info_box_adv'),
		),	
		
    //  User showroom table     
    'table_add' => array(
        array('phpbb_info_boxes', array(
            'COLUMNS'      => array(
                'info_boxes_id'        	=> array('UINT', NULL, 'auto_increment'),
				'title'					=> array('VCHAR:255', ''),
                'message'  				=> array('TEXT', ''),
				'time'					=> array('INT:11', 0),
				'display_index'			=> array('BOOL', 1),
				'display_all_pages'		=> array('BOOL', 0),
				'enable_info_box_warn'	=> array('BOOL', 0),
				'update_time'			=> array('INT:11', 0),
				'display_until'			=> array('INT:11', 0),
				'border_color'			=> array('VCHAR:35', ''),
				'background_color'		=> array('VCHAR:35', ''),
                'bbcode_bitfield'   	=> array('VCHAR:255', ''),
                'bbcode_uid'        	=> array('VCHAR:8', ''),				

				),                            			                                 
                'PRIMARY_KEY'   =>  'info_boxes_id', 				
            ),
        ), 	
	),
),
	// Version 1.0.1
    '1.0.1'   => array(
		
	// Lets add a config setting and set it to true
		'config_add' => array(
			array('enable_archive_limit', 1),
			array('archive_limit', '10'),
        ),
	),
	
	// Version 1.0.1
    '1.0.2'   => array(
        'table_column_add' => array(
            array('phpbb_info_boxes', 'display_end', array('BOOL', 0)),

        ),      
    ),
	
	// Version 1.0.3
    '1.0.3'   => array(
        
		'table_column_add' => array(
            array('phpbb_info_boxes', 'info_image', array('VCHAR:255', '')),
        ),  
		
		'config_add' => array(
			array('info_path', 'images/info_boxes'),
        ),	
	),
	// Version 1.0.4
    '1.0.4'   => array(
    // fixes for validation
	// clear the cache and refresh
		'cache_purge' => array('', 'template', 'theme'),		
	),		
			
);     

// Include the UMIF Auto file and everything else will be handled automatically.
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

?>